import{S as cs,i as fs,s as ms,e as n,k as c,w as m,t as o,M as hs,c as s,d as t,m as f,a as r,x as h,h as p,b as u,N as us,G as i,g as l,y as _,L as _s,q as d,o as g,B as v,v as ds}from"../../chunks/vendor-hf-doc-builder.js";import{I as Re}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as P}from"../../chunks/CodeBlock-hf-doc-builder.js";function gs(Qa){let A,$t,I,O,ze,Y,$i,Be,yi,yt,J,K,bi,Ei,bt,Q,V,Va,Et,Ae,ki,kt,X,Z,Xa,Pt,N,Pi,Ue,Ai,Ii,At,Ie,We,w,qi,Fe,Ti,ji,ee,Di,Si,te,Oi,Ni,ie,Mi,Ci,It,q,M,Ye,ae,Li,Je,Gi,qt,T,C,Ke,ne,Hi,Qe,Ri,Tt,qe,zi,jt,Te,Ve,Bi,Dt,L,Ui,Xe,Wi,Fi,St,se,Ot,je,Yi,Nt,re,Mt,G,Ji,le,Ki,Qi,Ct,oe,Lt,De,Vi,Gt,pe,Ht,Se,Xi,Rt,ue,zt,j,H,Ze,ce,Zi,et,ea,Bt,b,ta,fe,ia,aa,me,na,sa,Ut,Oe,ra,Wt,he,Ft,Ne,la,Yt,_e,Jt,R,oa,tt,pa,ua,Kt,de,Qt,x,ca,it,fa,ma,at,ha,_a,nt,da,ga,Vt,ge,ve,va,wa,Xt,Me,st,rt,xa,Zt,D,z,lt,we,$a,ot,ya,ei,y,pt,ba,Ea,xe,ka,Pa,ut,Aa,Ia,ti,$e,ii,S,B,ct,ye,qa,ft,Ta,ai,Ce,ja,ni,be,si,U,Da,Ee,Sa,Oa,ri,Le,Na,li,E,mt,ht,Ma,Ca,_t,dt,La,Ga,gt,vt,Ha,oi,$,Ra,wt,za,Ba,xt,Ua,Wa,ke,Fa,Ya,pi;return Y=new Re({}),ae=new Re({}),ne=new Re({}),se=new P({props:{code:`git clone https://github.com/huggingface/diffusers
cd diffusers
pip install -e .`,highlighted:`git <span class="hljs-built_in">clone</span> https://github.com/huggingface/diffusers
<span class="hljs-built_in">cd</span> diffusers
pip install -e .`}}),re=new P({props:{code:"pip install -r requirements.txt",highlighted:"pip install -r requirements.txt"}}),oe=new P({props:{code:"accelerate config",highlighted:"accelerate config"}}),pe=new P({props:{code:"accelerate config default",highlighted:"accelerate config default"}}),ue=new P({props:{code:`from accelerate.utils import write_basic_config

write_basic_config()`,highlighted:`<span class="hljs-keyword">from</span> accelerate.utils <span class="hljs-keyword">import</span> write_basic_config

write_basic_config()`}}),ce=new Re({}),he=new P({props:{code:`export MODEL_NAME="runwayml/stable-diffusion-v1-5"
export DATASET_ID="fusing/instructpix2pix-1000-samples"`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
<span class="hljs-built_in">export</span> DATASET_ID=<span class="hljs-string">&quot;fusing/instructpix2pix-1000-samples&quot;</span>`}}),_e=new P({props:{code:`accelerate launch --mixed_precision="fp16" train_instruct_pix2pix.py \\
    --pretrained_model_name_or_path=$MODEL_NAME \\
    --dataset_name=$DATASET_ID \\
    --enable_xformers_memory_efficient_attention \\
    --resolution=256 --random_flip \\
    --train_batch_size=4 --gradient_accumulation_steps=4 --gradient_checkpointing \\
    --max_train_steps=15000 \\
    --checkpointing_steps=5000 --checkpoints_total_limit=1 \\
    --learning_rate=5e-05 --max_grad_norm=1 --lr_warmup_steps=0 \\
    --conditioning_dropout_prob=0.05 \\
    --mixed_precision=fp16 \\
    --seed=42 `,highlighted:`accelerate launch --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> train_instruct_pix2pix.py \\
    --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
    --dataset_name=<span class="hljs-variable">$DATASET_ID</span> \\
    --enable_xformers_memory_efficient_attention \\
    --resolution=256 --random_flip \\
    --train_batch_size=4 --gradient_accumulation_steps=4 --gradient_checkpointing \\
    --max_train_steps=15000 \\
    --checkpointing_steps=5000 --checkpoints_total_limit=1 \\
    --learning_rate=5e-05 --max_grad_norm=1 --lr_warmup_steps=0 \\
    --conditioning_dropout_prob=0.05 \\
    --mixed_precision=fp16 \\
    --seed=42 `}}),de=new P({props:{code:`accelerate launch --mixed_precision="fp16" train_instruct_pix2pix.py \\
    --pretrained_model_name_or_path=$MODEL_NAME \\
    --dataset_name=$DATASET_ID \\
    --enable_xformers_memory_efficient_attention \\
    --resolution=256 --random_flip \\
    --train_batch_size=4 --gradient_accumulation_steps=4 --gradient_checkpointing \\
    --max_train_steps=15000 \\
    --checkpointing_steps=5000 --checkpoints_total_limit=1 \\
    --learning_rate=5e-05 --max_grad_norm=1 --lr_warmup_steps=0 \\
    --conditioning_dropout_prob=0.05 \\
    --mixed_precision=fp16 \\
    --val_image_url="https://hf.co/datasets/diffusers/diffusers-images-docs/resolve/main/mountain.png" \\
    --validation_prompt="make the mountains snowy" \\
    --seed=42 \\
    --report_to=wandb `,highlighted:`accelerate launch --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> train_instruct_pix2pix.py \\
    --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
    --dataset_name=<span class="hljs-variable">$DATASET_ID</span> \\
    --enable_xformers_memory_efficient_attention \\
    --resolution=256 --random_flip \\
    --train_batch_size=4 --gradient_accumulation_steps=4 --gradient_checkpointing \\
    --max_train_steps=15000 \\
    --checkpointing_steps=5000 --checkpoints_total_limit=1 \\
    --learning_rate=5e-05 --max_grad_norm=1 --lr_warmup_steps=0 \\
    --conditioning_dropout_prob=0.05 \\
    --mixed_precision=fp16 \\
    --val_image_url=<span class="hljs-string">&quot;https://hf.co/datasets/diffusers/diffusers-images-docs/resolve/main/mountain.png&quot;</span> \\
    --validation_prompt=<span class="hljs-string">&quot;make the mountains snowy&quot;</span> \\
    --seed=42 \\
    --report_to=wandb `}}),we=new Re({}),$e=new P({props:{code:`accelerate launch --mixed_precision="fp16" --multi_gpu train_instruct_pix2pix.py \\
 --pretrained_model_name_or_path=runwayml/stable-diffusion-v1-5 \\
 --dataset_name=sayakpaul/instructpix2pix-1000-samples \\
 --use_ema \\
 --enable_xformers_memory_efficient_attention \\
 --resolution=512 --random_flip \\
 --train_batch_size=4 --gradient_accumulation_steps=4 --gradient_checkpointing \\
 --max_train_steps=15000 \\
 --checkpointing_steps=5000 --checkpoints_total_limit=1 \\
 --learning_rate=5e-05 --lr_warmup_steps=0 \\
 --conditioning_dropout_prob=0.05 \\
 --mixed_precision=fp16 \\
 --seed=42 `,highlighted:`accelerate launch --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> --multi_gpu train_instruct_pix2pix.py \\
 --pretrained_model_name_or_path=runwayml/stable-diffusion-v1-5 \\
 --dataset_name=sayakpaul/instructpix2pix-1000-samples \\
 --use_ema \\
 --enable_xformers_memory_efficient_attention \\
 --resolution=512 --random_flip \\
 --train_batch_size=4 --gradient_accumulation_steps=4 --gradient_checkpointing \\
 --max_train_steps=15000 \\
 --checkpointing_steps=5000 --checkpoints_total_limit=1 \\
 --learning_rate=5e-05 --lr_warmup_steps=0 \\
 --conditioning_dropout_prob=0.05 \\
 --mixed_precision=fp16 \\
 --seed=42 `}}),ye=new Re({}),be=new P({props:{code:`import PIL
import requests
import torch
from diffusers import StableDiffusionInstructPix2PixPipeline

model_id = "your_model_id"  # <- replace this
pipe = StableDiffusionInstructPix2PixPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")
generator = torch.Generator("cuda").manual_seed(0)

url = "https://huggingface.co/datasets/sayakpaul/sample-datasets/resolve/main/test_pix2pix_4.png"


def download_image(url):
   image = PIL.Image.open(requests.get(url, stream=True).raw)
   image = PIL.ImageOps.exif_transpose(image)
   image = image.convert("RGB")
   return image


image = download_image(url)
prompt = "wipe out the lake"
num_inference_steps = 20
image_guidance_scale = 1.5
guidance_scale = 10

edited_image = pipe(
   prompt,
   image=image,
   num_inference_steps=num_inference_steps,
   image_guidance_scale=image_guidance_scale,
   guidance_scale=guidance_scale,
   generator=generator,
).images[0]
edited_image.save("edited_image.png")`,highlighted:`<span class="hljs-keyword">import</span> PIL
<span class="hljs-keyword">import</span> requests
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionInstructPix2PixPipeline

model_id = <span class="hljs-string">&quot;your_model_id&quot;</span>  <span class="hljs-comment"># &lt;- replace this</span>
pipe = StableDiffusionInstructPix2PixPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)
generator = torch.Generator(<span class="hljs-string">&quot;cuda&quot;</span>).manual_seed(<span class="hljs-number">0</span>)

url = <span class="hljs-string">&quot;https://huggingface.co/datasets/sayakpaul/sample-datasets/resolve/main/test_pix2pix_4.png&quot;</span>


<span class="hljs-keyword">def</span> <span class="hljs-title function_">download_image</span>(<span class="hljs-params">url</span>):
   image = PIL.Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)
   image = PIL.ImageOps.exif_transpose(image)
   image = image.convert(<span class="hljs-string">&quot;RGB&quot;</span>)
   <span class="hljs-keyword">return</span> image


image = download_image(url)
prompt = <span class="hljs-string">&quot;wipe out the lake&quot;</span>
num_inference_steps = <span class="hljs-number">20</span>
image_guidance_scale = <span class="hljs-number">1.5</span>
guidance_scale = <span class="hljs-number">10</span>

edited_image = pipe(
   prompt,
   image=image,
   num_inference_steps=num_inference_steps,
   image_guidance_scale=image_guidance_scale,
   guidance_scale=guidance_scale,
   generator=generator,
).images[<span class="hljs-number">0</span>]
edited_image.save(<span class="hljs-string">&quot;edited_image.png&quot;</span>)`}}),{c(){A=n("meta"),$t=c(),I=n("h1"),O=n("a"),ze=n("span"),m(Y.$$.fragment),$i=c(),Be=n("span"),yi=o("InstructPix2Pix"),yt=c(),J=n("p"),K=n("a"),bi=o("InstructPix2Pix"),Ei=o(" is a method to fine-tune text-conditioned diffusion models such that they can follow an edit instruction for an input image. Models fine-tuned using this method take the following as inputs:"),bt=c(),Q=n("p"),V=n("img"),Et=c(),Ae=n("p"),ki=o("The output is an \u201Cedited\u201D image that reflects the edit instruction applied on the input image:"),kt=c(),X=n("p"),Z=n("img"),Pt=c(),N=n("p"),Pi=o("The "),Ue=n("code"),Ai=o("train_instruct_pix2pix.py"),Ii=o(" script shows how to implement the training procedure and adapt it for Stable Diffusion."),At=c(),Ie=n("p"),We=n("strong"),w=n("em"),qi=o("Disclaimer: Even though "),Fe=n("code"),Ti=o("train_instruct_pix2pix.py"),ji=o(` implements the InstructPix2Pix
training procedure while being faithful to the `),ee=n("a"),Di=o("original implementation"),Si=o(" we have only tested it on a "),te=n("a"),Oi=o("small-scale dataset"),Ni=o(". This can impact the end results. For better results, we recommend longer training runs with a larger dataset. "),ie=n("a"),Mi=o("Here"),Ci=o(" you can find a large dataset for InstructPix2Pix training."),It=c(),q=n("h2"),M=n("a"),Ye=n("span"),m(ae.$$.fragment),Li=c(),Je=n("span"),Gi=o("Running locally with PyTorch"),qt=c(),T=n("h3"),C=n("a"),Ke=n("span"),m(ne.$$.fragment),Hi=c(),Qe=n("span"),Ri=o("Installing the dependencies"),Tt=c(),qe=n("p"),zi=o("Before running the scripts, make sure to install the library\u2019s training dependencies:"),jt=c(),Te=n("p"),Ve=n("strong"),Bi=o("Important"),Dt=c(),L=n("p"),Ui=o("To make sure you can successfully run the latest versions of the example scripts, we highly recommend "),Xe=n("strong"),Wi=o("installing from source"),Fi=o(" and keeping the install up to date as we update the example scripts frequently and install some example-specific requirements. To do this, execute the following steps in a new virtual environment:"),St=c(),m(se.$$.fragment),Ot=c(),je=n("p"),Yi=o("Then cd in the example folder and run"),Nt=c(),m(re.$$.fragment),Mt=c(),G=n("p"),Ji=o("And initialize an "),le=n("a"),Ki=o("\u{1F917}Accelerate"),Qi=o(" environment with:"),Ct=c(),m(oe.$$.fragment),Lt=c(),De=n("p"),Vi=o("Or for a default accelerate configuration without answering questions about your environment"),Gt=c(),m(pe.$$.fragment),Ht=c(),Se=n("p"),Xi=o("Or if your environment doesn\u2019t support an interactive shell e.g. a notebook"),Rt=c(),m(ue.$$.fragment),zt=c(),j=n("h3"),H=n("a"),Ze=n("span"),m(ce.$$.fragment),Zi=c(),et=n("span"),ea=o("Toy example"),Bt=c(),b=n("p"),ta=o("As mentioned before, we\u2019ll use a "),fe=n("a"),ia=o("small toy dataset"),aa=o(` for training. The dataset
is a smaller version of the `),me=n("a"),na=o("original dataset"),sa=o(" used in the InstructPix2Pix paper."),Ut=c(),Oe=n("p"),ra=o(`Configure environment variables such as the dataset identifier and the Stable Diffusion
checkpoint:`),Wt=c(),m(he.$$.fragment),Ft=c(),Ne=n("p"),la=o("Now, we can launch training:"),Yt=c(),m(_e.$$.fragment),Jt=c(),R=n("p"),oa=o(`Additionally, we support performing validation inference to monitor training progress
with Weights and Biases. You can enable this feature with `),tt=n("code"),pa=o('report_to="wandb"'),ua=o(":"),Kt=c(),m(de.$$.fragment),Qt=c(),x=n("p"),ca=o("We recommend this type of validation as it can be useful for model debugging. Note that you need "),it=n("code"),fa=o("wandb"),ma=o(" installed to use this. You can install "),at=n("code"),ha=o("wandb"),_a=o(" by running "),nt=n("code"),da=o("pip install wandb"),ga=o("."),Vt=c(),ge=n("p"),ve=n("a"),va=o("Here"),wa=o(", you can find an example training run that includes some validation samples and the training hyperparameters."),Xt=c(),Me=n("p"),st=n("strong"),rt=n("em"),xa=o("Note: In the original paper, the authors observed that even when the model is trained with an image resolution of 256x256, it generalizes well to bigger resolutions such as 512x512. This is likely because of the larger dataset they used during training."),Zt=c(),D=n("h2"),z=n("a"),lt=n("span"),m(we.$$.fragment),$a=c(),ot=n("span"),ya=o("Training with multiple GPUs"),ei=c(),y=n("p"),pt=n("code"),ba=o("accelerate"),Ea=o(" allows for seamless multi-GPU training. Follow the instructions "),xe=n("a"),ka=o("here"),Pa=o(`
for running distributed training with `),ut=n("code"),Aa=o("accelerate"),Ia=o(". Here is an example command:"),ti=c(),m($e.$$.fragment),ii=c(),S=n("h2"),B=n("a"),ct=n("span"),m(ye.$$.fragment),qa=c(),ft=n("span"),Ta=o("Inference"),ai=c(),Ce=n("p"),ja=o("Once training is complete, we can perform inference:"),ni=c(),m(be.$$.fragment),si=c(),U=n("p"),Da=o(`An example model repo obtained using this training script can be found
here - `),Ee=n("a"),Sa=o("sayakpaul/instruct-pix2pix"),Oa=o("."),ri=c(),Le=n("p"),Na=o(`We encourage you to play with the following three parameters to control
speed and quality during performance:`),li=c(),E=n("ul"),mt=n("li"),ht=n("code"),Ma=o("num_inference_steps"),Ca=c(),_t=n("li"),dt=n("code"),La=o("image_guidance_scale"),Ga=c(),gt=n("li"),vt=n("code"),Ha=o("guidance_scale"),oi=c(),$=n("p"),Ra=o("Particularly, "),wt=n("code"),za=o("image_guidance_scale"),Ba=o(" and "),xt=n("code"),Ua=o("guidance_scale"),Wa=o(` can have a profound impact
on the generated (\u201Cedited\u201D) image (see `),ke=n("a"),Fa=o("here"),Ya=o(" for an example)."),this.h()},l(e){const a=hs('[data-svelte="svelte-1phssyn"]',document.head);A=s(a,"META",{name:!0,content:!0}),a.forEach(t),$t=f(e),I=s(e,"H1",{class:!0});var ui=r(I);O=s(ui,"A",{id:!0,class:!0,href:!0});var Za=r(O);ze=s(Za,"SPAN",{});var en=r(ze);h(Y.$$.fragment,en),en.forEach(t),Za.forEach(t),$i=f(ui),Be=s(ui,"SPAN",{});var tn=r(Be);yi=p(tn,"InstructPix2Pix"),tn.forEach(t),ui.forEach(t),yt=f(e),J=s(e,"P",{});var Ja=r(J);K=s(Ja,"A",{href:!0,rel:!0});var an=r(K);bi=p(an,"InstructPix2Pix"),an.forEach(t),Ei=p(Ja," is a method to fine-tune text-conditioned diffusion models such that they can follow an edit instruction for an input image. Models fine-tuned using this method take the following as inputs:"),Ja.forEach(t),bt=f(e),Q=s(e,"P",{align:!0});var nn=r(Q);V=s(nn,"IMG",{src:!0,alt:!0,width:!0}),nn.forEach(t),Et=f(e),Ae=s(e,"P",{});var sn=r(Ae);ki=p(sn,"The output is an \u201Cedited\u201D image that reflects the edit instruction applied on the input image:"),sn.forEach(t),kt=f(e),X=s(e,"P",{align:!0});var rn=r(X);Z=s(rn,"IMG",{src:!0,alt:!0,width:!0}),rn.forEach(t),Pt=f(e),N=s(e,"P",{});var ci=r(N);Pi=p(ci,"The "),Ue=s(ci,"CODE",{});var ln=r(Ue);Ai=p(ln,"train_instruct_pix2pix.py"),ln.forEach(t),Ii=p(ci," script shows how to implement the training procedure and adapt it for Stable Diffusion."),ci.forEach(t),At=f(e),Ie=s(e,"P",{});var on=r(Ie);We=s(on,"STRONG",{});var pn=r(We);w=s(pn,"EM",{});var k=r(w);qi=p(k,"Disclaimer: Even though "),Fe=s(k,"CODE",{});var un=r(Fe);Ti=p(un,"train_instruct_pix2pix.py"),un.forEach(t),ji=p(k,` implements the InstructPix2Pix
training procedure while being faithful to the `),ee=s(k,"A",{href:!0,rel:!0});var cn=r(ee);Di=p(cn,"original implementation"),cn.forEach(t),Si=p(k," we have only tested it on a "),te=s(k,"A",{href:!0,rel:!0});var fn=r(te);Oi=p(fn,"small-scale dataset"),fn.forEach(t),Ni=p(k,". This can impact the end results. For better results, we recommend longer training runs with a larger dataset. "),ie=s(k,"A",{href:!0,rel:!0});var mn=r(ie);Mi=p(mn,"Here"),mn.forEach(t),Ci=p(k," you can find a large dataset for InstructPix2Pix training."),k.forEach(t),pn.forEach(t),on.forEach(t),It=f(e),q=s(e,"H2",{class:!0});var fi=r(q);M=s(fi,"A",{id:!0,class:!0,href:!0});var hn=r(M);Ye=s(hn,"SPAN",{});var _n=r(Ye);h(ae.$$.fragment,_n),_n.forEach(t),hn.forEach(t),Li=f(fi),Je=s(fi,"SPAN",{});var dn=r(Je);Gi=p(dn,"Running locally with PyTorch"),dn.forEach(t),fi.forEach(t),qt=f(e),T=s(e,"H3",{class:!0});var mi=r(T);C=s(mi,"A",{id:!0,class:!0,href:!0});var gn=r(C);Ke=s(gn,"SPAN",{});var vn=r(Ke);h(ne.$$.fragment,vn),vn.forEach(t),gn.forEach(t),Hi=f(mi),Qe=s(mi,"SPAN",{});var wn=r(Qe);Ri=p(wn,"Installing the dependencies"),wn.forEach(t),mi.forEach(t),Tt=f(e),qe=s(e,"P",{});var xn=r(qe);zi=p(xn,"Before running the scripts, make sure to install the library\u2019s training dependencies:"),xn.forEach(t),jt=f(e),Te=s(e,"P",{});var $n=r(Te);Ve=s($n,"STRONG",{});var yn=r(Ve);Bi=p(yn,"Important"),yn.forEach(t),$n.forEach(t),Dt=f(e),L=s(e,"P",{});var hi=r(L);Ui=p(hi,"To make sure you can successfully run the latest versions of the example scripts, we highly recommend "),Xe=s(hi,"STRONG",{});var bn=r(Xe);Wi=p(bn,"installing from source"),bn.forEach(t),Fi=p(hi," and keeping the install up to date as we update the example scripts frequently and install some example-specific requirements. To do this, execute the following steps in a new virtual environment:"),hi.forEach(t),St=f(e),h(se.$$.fragment,e),Ot=f(e),je=s(e,"P",{});var En=r(je);Yi=p(En,"Then cd in the example folder and run"),En.forEach(t),Nt=f(e),h(re.$$.fragment,e),Mt=f(e),G=s(e,"P",{});var _i=r(G);Ji=p(_i,"And initialize an "),le=s(_i,"A",{href:!0,rel:!0});var kn=r(le);Ki=p(kn,"\u{1F917}Accelerate"),kn.forEach(t),Qi=p(_i," environment with:"),_i.forEach(t),Ct=f(e),h(oe.$$.fragment,e),Lt=f(e),De=s(e,"P",{});var Pn=r(De);Vi=p(Pn,"Or for a default accelerate configuration without answering questions about your environment"),Pn.forEach(t),Gt=f(e),h(pe.$$.fragment,e),Ht=f(e),Se=s(e,"P",{});var An=r(Se);Xi=p(An,"Or if your environment doesn\u2019t support an interactive shell e.g. a notebook"),An.forEach(t),Rt=f(e),h(ue.$$.fragment,e),zt=f(e),j=s(e,"H3",{class:!0});var di=r(j);H=s(di,"A",{id:!0,class:!0,href:!0});var In=r(H);Ze=s(In,"SPAN",{});var qn=r(Ze);h(ce.$$.fragment,qn),qn.forEach(t),In.forEach(t),Zi=f(di),et=s(di,"SPAN",{});var Tn=r(et);ea=p(Tn,"Toy example"),Tn.forEach(t),di.forEach(t),Bt=f(e),b=s(e,"P",{});var Ge=r(b);ta=p(Ge,"As mentioned before, we\u2019ll use a "),fe=s(Ge,"A",{href:!0,rel:!0});var jn=r(fe);ia=p(jn,"small toy dataset"),jn.forEach(t),aa=p(Ge,` for training. The dataset
is a smaller version of the `),me=s(Ge,"A",{href:!0,rel:!0});var Dn=r(me);na=p(Dn,"original dataset"),Dn.forEach(t),sa=p(Ge," used in the InstructPix2Pix paper."),Ge.forEach(t),Ut=f(e),Oe=s(e,"P",{});var Sn=r(Oe);ra=p(Sn,`Configure environment variables such as the dataset identifier and the Stable Diffusion
checkpoint:`),Sn.forEach(t),Wt=f(e),h(he.$$.fragment,e),Ft=f(e),Ne=s(e,"P",{});var On=r(Ne);la=p(On,"Now, we can launch training:"),On.forEach(t),Yt=f(e),h(_e.$$.fragment,e),Jt=f(e),R=s(e,"P",{});var gi=r(R);oa=p(gi,`Additionally, we support performing validation inference to monitor training progress
with Weights and Biases. You can enable this feature with `),tt=s(gi,"CODE",{});var Nn=r(tt);pa=p(Nn,'report_to="wandb"'),Nn.forEach(t),ua=p(gi,":"),gi.forEach(t),Kt=f(e),h(de.$$.fragment,e),Qt=f(e),x=s(e,"P",{});var W=r(x);ca=p(W,"We recommend this type of validation as it can be useful for model debugging. Note that you need "),it=s(W,"CODE",{});var Mn=r(it);fa=p(Mn,"wandb"),Mn.forEach(t),ma=p(W," installed to use this. You can install "),at=s(W,"CODE",{});var Cn=r(at);ha=p(Cn,"wandb"),Cn.forEach(t),_a=p(W," by running "),nt=s(W,"CODE",{});var Ln=r(nt);da=p(Ln,"pip install wandb"),Ln.forEach(t),ga=p(W,"."),W.forEach(t),Vt=f(e),ge=s(e,"P",{});var Ka=r(ge);ve=s(Ka,"A",{href:!0,rel:!0});var Gn=r(ve);va=p(Gn,"Here"),Gn.forEach(t),wa=p(Ka,", you can find an example training run that includes some validation samples and the training hyperparameters."),Ka.forEach(t),Xt=f(e),Me=s(e,"P",{});var Hn=r(Me);st=s(Hn,"STRONG",{});var Rn=r(st);rt=s(Rn,"EM",{});var zn=r(rt);xa=p(zn,"Note: In the original paper, the authors observed that even when the model is trained with an image resolution of 256x256, it generalizes well to bigger resolutions such as 512x512. This is likely because of the larger dataset they used during training."),zn.forEach(t),Rn.forEach(t),Hn.forEach(t),Zt=f(e),D=s(e,"H2",{class:!0});var vi=r(D);z=s(vi,"A",{id:!0,class:!0,href:!0});var Bn=r(z);lt=s(Bn,"SPAN",{});var Un=r(lt);h(we.$$.fragment,Un),Un.forEach(t),Bn.forEach(t),$a=f(vi),ot=s(vi,"SPAN",{});var Wn=r(ot);ya=p(Wn,"Training with multiple GPUs"),Wn.forEach(t),vi.forEach(t),ei=f(e),y=s(e,"P",{});var Pe=r(y);pt=s(Pe,"CODE",{});var Fn=r(pt);ba=p(Fn,"accelerate"),Fn.forEach(t),Ea=p(Pe," allows for seamless multi-GPU training. Follow the instructions "),xe=s(Pe,"A",{href:!0,rel:!0});var Yn=r(xe);ka=p(Yn,"here"),Yn.forEach(t),Pa=p(Pe,`
for running distributed training with `),ut=s(Pe,"CODE",{});var Jn=r(ut);Aa=p(Jn,"accelerate"),Jn.forEach(t),Ia=p(Pe,". Here is an example command:"),Pe.forEach(t),ti=f(e),h($e.$$.fragment,e),ii=f(e),S=s(e,"H2",{class:!0});var wi=r(S);B=s(wi,"A",{id:!0,class:!0,href:!0});var Kn=r(B);ct=s(Kn,"SPAN",{});var Qn=r(ct);h(ye.$$.fragment,Qn),Qn.forEach(t),Kn.forEach(t),qa=f(wi),ft=s(wi,"SPAN",{});var Vn=r(ft);Ta=p(Vn,"Inference"),Vn.forEach(t),wi.forEach(t),ai=f(e),Ce=s(e,"P",{});var Xn=r(Ce);ja=p(Xn,"Once training is complete, we can perform inference:"),Xn.forEach(t),ni=f(e),h(be.$$.fragment,e),si=f(e),U=s(e,"P",{});var xi=r(U);Da=p(xi,`An example model repo obtained using this training script can be found
here - `),Ee=s(xi,"A",{href:!0,rel:!0});var Zn=r(Ee);Sa=p(Zn,"sayakpaul/instruct-pix2pix"),Zn.forEach(t),Oa=p(xi,"."),xi.forEach(t),ri=f(e),Le=s(e,"P",{});var es=r(Le);Na=p(es,`We encourage you to play with the following three parameters to control
speed and quality during performance:`),es.forEach(t),li=f(e),E=s(e,"UL",{});var He=r(E);mt=s(He,"LI",{});var ts=r(mt);ht=s(ts,"CODE",{});var is=r(ht);Ma=p(is,"num_inference_steps"),is.forEach(t),ts.forEach(t),Ca=f(He),_t=s(He,"LI",{});var as=r(_t);dt=s(as,"CODE",{});var ns=r(dt);La=p(ns,"image_guidance_scale"),ns.forEach(t),as.forEach(t),Ga=f(He),gt=s(He,"LI",{});var ss=r(gt);vt=s(ss,"CODE",{});var rs=r(vt);Ha=p(rs,"guidance_scale"),rs.forEach(t),ss.forEach(t),He.forEach(t),oi=f(e),$=s(e,"P",{});var F=r($);Ra=p(F,"Particularly, "),wt=s(F,"CODE",{});var ls=r(wt);za=p(ls,"image_guidance_scale"),ls.forEach(t),Ba=p(F," and "),xt=s(F,"CODE",{});var os=r(xt);Ua=p(os,"guidance_scale"),os.forEach(t),Wa=p(F,` can have a profound impact
on the generated (\u201Cedited\u201D) image (see `),ke=s(F,"A",{href:!0,rel:!0});var ps=r(ke);Fa=p(ps,"here"),ps.forEach(t),Ya=p(F," for an example)."),F.forEach(t),this.h()},h(){u(A,"name","hf:doc:metadata"),u(A,"content",JSON.stringify(vs)),u(O,"id","instructpix2pix"),u(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(O,"href","#instructpix2pix"),u(I,"class","relative group"),u(K,"href","https://arxiv.org/abs/2211.09800"),u(K,"rel","nofollow"),us(V.src,Va="https://huggingface.co/datasets/diffusers/docs-images/resolve/main/evaluation_diffusion_models/edit-instruction.png")||u(V,"src",Va),u(V,"alt","instructpix2pix-inputs"),u(V,"width","600"),u(Q,"align","center"),us(Z.src,Xa="https://huggingface.co/datasets/diffusers/docs-images/resolve/main/output-gs%407-igs%401-steps%4050.png")||u(Z,"src",Xa),u(Z,"alt","instructpix2pix-output"),u(Z,"width","600"),u(X,"align","center"),u(ee,"href","https://github.com/timothybrooks/instruct-pix2pix"),u(ee,"rel","nofollow"),u(te,"href","https://huggingface.co/datasets/fusing/instructpix2pix-1000-samples"),u(te,"rel","nofollow"),u(ie,"href","https://huggingface.co/datasets/timbrooks/instructpix2pix-clip-filtered"),u(ie,"rel","nofollow"),u(M,"id","running-locally-with-pytorch"),u(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(M,"href","#running-locally-with-pytorch"),u(q,"class","relative group"),u(C,"id","installing-the-dependencies"),u(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(C,"href","#installing-the-dependencies"),u(T,"class","relative group"),u(le,"href","https://github.com/huggingface/accelerate/"),u(le,"rel","nofollow"),u(H,"id","toy-example"),u(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(H,"href","#toy-example"),u(j,"class","relative group"),u(fe,"href","https://huggingface.co/datasets/fusing/instructpix2pix-1000-samples"),u(fe,"rel","nofollow"),u(me,"href","https://huggingface.co/datasets/timbrooks/instructpix2pix-clip-filtered"),u(me,"rel","nofollow"),u(ve,"href","https://wandb.ai/sayakpaul/instruct-pix2pix/runs/ctr3kovq"),u(ve,"rel","nofollow"),u(z,"id","training-with-multiple-gpus"),u(z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(z,"href","#training-with-multiple-gpus"),u(D,"class","relative group"),u(xe,"href","https://huggingface.co/docs/accelerate/basic_tutorials/launch"),u(xe,"rel","nofollow"),u(B,"id","inference"),u(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(B,"href","#inference"),u(S,"class","relative group"),u(Ee,"href","https://huggingface.co/sayakpaul/instruct-pix2pix"),u(Ee,"rel","nofollow"),u(ke,"href","https://twitter.com/RisingSayak/status/1628392199196151808?s=20"),u(ke,"rel","nofollow")},m(e,a){i(document.head,A),l(e,$t,a),l(e,I,a),i(I,O),i(O,ze),_(Y,ze,null),i(I,$i),i(I,Be),i(Be,yi),l(e,yt,a),l(e,J,a),i(J,K),i(K,bi),i(J,Ei),l(e,bt,a),l(e,Q,a),i(Q,V),l(e,Et,a),l(e,Ae,a),i(Ae,ki),l(e,kt,a),l(e,X,a),i(X,Z),l(e,Pt,a),l(e,N,a),i(N,Pi),i(N,Ue),i(Ue,Ai),i(N,Ii),l(e,At,a),l(e,Ie,a),i(Ie,We),i(We,w),i(w,qi),i(w,Fe),i(Fe,Ti),i(w,ji),i(w,ee),i(ee,Di),i(w,Si),i(w,te),i(te,Oi),i(w,Ni),i(w,ie),i(ie,Mi),i(w,Ci),l(e,It,a),l(e,q,a),i(q,M),i(M,Ye),_(ae,Ye,null),i(q,Li),i(q,Je),i(Je,Gi),l(e,qt,a),l(e,T,a),i(T,C),i(C,Ke),_(ne,Ke,null),i(T,Hi),i(T,Qe),i(Qe,Ri),l(e,Tt,a),l(e,qe,a),i(qe,zi),l(e,jt,a),l(e,Te,a),i(Te,Ve),i(Ve,Bi),l(e,Dt,a),l(e,L,a),i(L,Ui),i(L,Xe),i(Xe,Wi),i(L,Fi),l(e,St,a),_(se,e,a),l(e,Ot,a),l(e,je,a),i(je,Yi),l(e,Nt,a),_(re,e,a),l(e,Mt,a),l(e,G,a),i(G,Ji),i(G,le),i(le,Ki),i(G,Qi),l(e,Ct,a),_(oe,e,a),l(e,Lt,a),l(e,De,a),i(De,Vi),l(e,Gt,a),_(pe,e,a),l(e,Ht,a),l(e,Se,a),i(Se,Xi),l(e,Rt,a),_(ue,e,a),l(e,zt,a),l(e,j,a),i(j,H),i(H,Ze),_(ce,Ze,null),i(j,Zi),i(j,et),i(et,ea),l(e,Bt,a),l(e,b,a),i(b,ta),i(b,fe),i(fe,ia),i(b,aa),i(b,me),i(me,na),i(b,sa),l(e,Ut,a),l(e,Oe,a),i(Oe,ra),l(e,Wt,a),_(he,e,a),l(e,Ft,a),l(e,Ne,a),i(Ne,la),l(e,Yt,a),_(_e,e,a),l(e,Jt,a),l(e,R,a),i(R,oa),i(R,tt),i(tt,pa),i(R,ua),l(e,Kt,a),_(de,e,a),l(e,Qt,a),l(e,x,a),i(x,ca),i(x,it),i(it,fa),i(x,ma),i(x,at),i(at,ha),i(x,_a),i(x,nt),i(nt,da),i(x,ga),l(e,Vt,a),l(e,ge,a),i(ge,ve),i(ve,va),i(ge,wa),l(e,Xt,a),l(e,Me,a),i(Me,st),i(st,rt),i(rt,xa),l(e,Zt,a),l(e,D,a),i(D,z),i(z,lt),_(we,lt,null),i(D,$a),i(D,ot),i(ot,ya),l(e,ei,a),l(e,y,a),i(y,pt),i(pt,ba),i(y,Ea),i(y,xe),i(xe,ka),i(y,Pa),i(y,ut),i(ut,Aa),i(y,Ia),l(e,ti,a),_($e,e,a),l(e,ii,a),l(e,S,a),i(S,B),i(B,ct),_(ye,ct,null),i(S,qa),i(S,ft),i(ft,Ta),l(e,ai,a),l(e,Ce,a),i(Ce,ja),l(e,ni,a),_(be,e,a),l(e,si,a),l(e,U,a),i(U,Da),i(U,Ee),i(Ee,Sa),i(U,Oa),l(e,ri,a),l(e,Le,a),i(Le,Na),l(e,li,a),l(e,E,a),i(E,mt),i(mt,ht),i(ht,Ma),i(E,Ca),i(E,_t),i(_t,dt),i(dt,La),i(E,Ga),i(E,gt),i(gt,vt),i(vt,Ha),l(e,oi,a),l(e,$,a),i($,Ra),i($,wt),i(wt,za),i($,Ba),i($,xt),i(xt,Ua),i($,Wa),i($,ke),i(ke,Fa),i($,Ya),pi=!0},p:_s,i(e){pi||(d(Y.$$.fragment,e),d(ae.$$.fragment,e),d(ne.$$.fragment,e),d(se.$$.fragment,e),d(re.$$.fragment,e),d(oe.$$.fragment,e),d(pe.$$.fragment,e),d(ue.$$.fragment,e),d(ce.$$.fragment,e),d(he.$$.fragment,e),d(_e.$$.fragment,e),d(de.$$.fragment,e),d(we.$$.fragment,e),d($e.$$.fragment,e),d(ye.$$.fragment,e),d(be.$$.fragment,e),pi=!0)},o(e){g(Y.$$.fragment,e),g(ae.$$.fragment,e),g(ne.$$.fragment,e),g(se.$$.fragment,e),g(re.$$.fragment,e),g(oe.$$.fragment,e),g(pe.$$.fragment,e),g(ue.$$.fragment,e),g(ce.$$.fragment,e),g(he.$$.fragment,e),g(_e.$$.fragment,e),g(de.$$.fragment,e),g(we.$$.fragment,e),g($e.$$.fragment,e),g(ye.$$.fragment,e),g(be.$$.fragment,e),pi=!1},d(e){t(A),e&&t($t),e&&t(I),v(Y),e&&t(yt),e&&t(J),e&&t(bt),e&&t(Q),e&&t(Et),e&&t(Ae),e&&t(kt),e&&t(X),e&&t(Pt),e&&t(N),e&&t(At),e&&t(Ie),e&&t(It),e&&t(q),v(ae),e&&t(qt),e&&t(T),v(ne),e&&t(Tt),e&&t(qe),e&&t(jt),e&&t(Te),e&&t(Dt),e&&t(L),e&&t(St),v(se,e),e&&t(Ot),e&&t(je),e&&t(Nt),v(re,e),e&&t(Mt),e&&t(G),e&&t(Ct),v(oe,e),e&&t(Lt),e&&t(De),e&&t(Gt),v(pe,e),e&&t(Ht),e&&t(Se),e&&t(Rt),v(ue,e),e&&t(zt),e&&t(j),v(ce),e&&t(Bt),e&&t(b),e&&t(Ut),e&&t(Oe),e&&t(Wt),v(he,e),e&&t(Ft),e&&t(Ne),e&&t(Yt),v(_e,e),e&&t(Jt),e&&t(R),e&&t(Kt),v(de,e),e&&t(Qt),e&&t(x),e&&t(Vt),e&&t(ge),e&&t(Xt),e&&t(Me),e&&t(Zt),e&&t(D),v(we),e&&t(ei),e&&t(y),e&&t(ti),v($e,e),e&&t(ii),e&&t(S),v(ye),e&&t(ai),e&&t(Ce),e&&t(ni),v(be,e),e&&t(si),e&&t(U),e&&t(ri),e&&t(Le),e&&t(li),e&&t(E),e&&t(oi),e&&t($)}}}const vs={local:"instructpix2pix",sections:[{local:"running-locally-with-pytorch",sections:[{local:"installing-the-dependencies",title:"Installing the dependencies"},{local:"toy-example",title:"Toy example"}],title:"Running locally with PyTorch"}],title:"InstructPix2Pix "};function ws(Qa){return ds(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class bs extends cs{constructor(A){super();fs(this,A,ws,gs,ms,{})}}export{bs as default,vs as metadata};
